Require Export Coq.Logic.FunctionalExtensionality.

(* The second requirement of [Fix_eq] is trivial if one assumes functional
   extensionality, as we do. We define a modified version of [Fix_eq] which
   does not have this requirement. *)

Lemma Fix_eq_ext:
  forall (A : Type) (R : A -> A -> Prop) (Rwf : well_founded R),
  forall (P : A -> Type),
  forall (F : forall x : A, (forall y : A, R y x -> P y) -> P x),
  forall x : A,
  Fix Rwf P F x = F x (fun y _ => Fix Rwf P F y).
Proof.
  intros. eapply Fix_eq. intros.
  assert (f = g).
    extensionality y. extensionality p. eauto.
  congruence.
Qed.

